/*
    Copyright (C) 2001  Tsinghuaeolus

    Authors : ChenJiang, YaoJinyi, CaiYunpeng, Lishi

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

	If you make any changes or have any comments we would appreciate a 
	message to yjy01@mails.tsinghua.edu.cn.
*/

#ifndef _global
#define _global

#include "netif.h"
#include "Objects.h"
#include "Types.h"
#include "Sensory.h"
#include "Params.h"
#include "command.h"
#include "motion.h"
#include "BPN.h"
#include "Strategy.h"
#include "RSAClass.h"
#include "logunit.h"
#include "stopwatch.h"
#include "mediator.h"
#include "df_positioning.h"
#include "kick.h"

extern UNum MyNumber;
extern Player MyTeam[SP_team_size];
extern Player TheirTeam[SP_team_size];

extern Player UnknownMyPlayers[2 * SP_team_size];
extern int num_unknown_myplayers;
extern Player UnknownTheirPlayers[2 * SP_team_size];
extern int num_unknown_theirplayers;
extern Player TeamlessPlayers[4 * SP_team_size];
extern int num_teamlessplayers;


extern Ball ball;
extern Object Markers[SP_num_markers+1];
extern Object Lines[SP_num_lines+1];

extern Sensory sensory;
extern Actions action;
extern Behaviors  motion;
extern Kick kick;
extern Situation situation;
extern Socket *sock;

extern char MyTeamName[30];
extern int MyTeamNameLen;
extern char TheirTeamName[30];
extern int TheirTeamNameLen;

extern int IP_reconnect;
extern int IP_MyScore;
extern int IP_TheirScore;


extern char cmdbuf[MAXMESG];
extern char recvbuf[MAXMESG];
extern char logbuf[MAXMESG];
extern char saybuf[MAXMESG];
extern char msgbuf[MAXMESG];
extern char recbuf[MAXMESG];

extern inline Player& MyPlayer(UNum No);
extern inline Player& TheirPlayer(UNum No);
extern inline Player& GetPlayer(char side, UNum No);
extern inline Player& GetPlayer(UNum No);

extern bool IsValidNo(UNum No);
extern bool IsUniformNo(UNum No);
extern bool IsMyPlayer(UNum No);
extern bool IsTheirPlayer(UNum No);
extern bool IsUnknownPlayer(UNum No);
extern MySelf Self;

extern Log rec;
extern Log recmsg;
extern LogData logdata;
extern FILE* fmatrix[CP_matrix_max];
extern Stopwatch watch;

extern HWND hWND;

extern bool Prepare_to_train;
extern bool Training_Successful;

extern int trainNo;

extern Mediator mediator;

extern Formation fm;

extern Field fieldinfo;

extern UnknownPlayerList unknowntheirplayerlist;
extern UnknownPlayerList unknownmyplayerlist;
extern UnknownPlayerList teamlessplayerlist;

extern int ServerAlive;
extern int NoResponseFromServer;

extern PlayerType playertypes[SP_max_playertypes];

//Log channels

#define LOG_NONE 0
#define LOG_SYNC 1
#define LOG_SENDACTION 2
#define LOG_STOPWATCH 3
#define LOG_MEDIATION 4
#define LOG_POSITIONING 5
#define LOG_ACTION 6
#define LOG_UPDATE 7
#define LOG_MISS 8
#define LOG_GOALIE 9
#define LOG_COLLIDE 10
#define LOG_KICK 11
#define LOG_UNKPLAYER 12
#define LOG_HEAR 13	
#define LOG_IT 14
#define LOG_PASS 15
#define LOG_SEE 16
#define LOG_DEFENSE 17
#define LOG_SETPLAY 18
#define LOG_BUG 19
#define LOG_SITUATION 20
#define LOG_DRIBBLE 21
#define LOG_OAKICK 22
#define LOG_VISUAL 23
#define LOG_DEFEXTEND 24
#define LOG_VDEC 26
#define LOG_VISUALREQ 27
#define LOG_SHOOT 28
#define LOG_HANDLEBALL 29
#define LOG_OFFSIDE 30

//#define _DEBUG_MOD
#endif