/*
    Copyright (C) 2001  Tsinghuaeolus

    Authors : ChenJiang, YaoJinyi, CaiYunpeng, Lishi

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

	If you make any changes or have any comments we would appreciate a 
	message to yjy01@mails.tsinghua.edu.cn.
*/

#ifndef _param
#define _param

#include "Types.h"
#include "Geometry.h"

extern float SP_pitch_length;
extern float SP_pitch_width;
extern float SP_semi_pitch_length;
extern float SP_semi_pitch_width;
extern float SP_pitch_diameter;
extern float SP_pitch_margin;
extern float SP_penalty_area_length;
extern float SP_penalty_area_width;
extern float SP_goal_area_length;
extern float SP_goal_area_width;
extern float SP_penalty_spot_dist;
extern float SP_corner_arc_r;
extern float SP_free_kick_buffer;
extern float SP_after_goal_wait;
extern float SP_feel_distance;
const int SP_num_lines = 4;
const int   SP_num_markers = 55;
extern float SP_unum_far_length;
extern float SP_unum_too_far_length;
extern float SP_team_far_length;
extern float SP_team_too_far_length;

extern float SP_version;
const int   SP_team_size = 11;
extern int SP_half;
extern float SP_goal_width;
extern float SP_player_size;
extern float SP_player_decay;
extern float SP_player_rand;
extern float SP_player_weight;
extern float SP_player_speed_max;
extern float SP_paccel_max;
extern float SP_stamina_max;
extern float SP_stamina_inc;
extern float SP_recover_init;
extern float SP_recover_dec_thr;
extern float SP_recover_dec;
extern float SP_recover_min;
extern float SP_effort_init;
extern float SP_effort_dec_thr;
extern float SP_effort_min;
extern float SP_effort_dec;
extern float SP_effort_inc_thr;
extern float SP_effort_inc;
extern float SP_kick_rand;
extern float SP_team_actuator_noise;
extern float SP_prand_factor_l;
extern float SP_prand_factor_r;
extern float SP_kick_rand_factor_l;
extern float SP_kick_rand_factor_r;
extern float SP_ball_size;
extern float SP_ball_decay;
extern float SP_ball_decay_ln;
extern float SP_ball_rand;
extern float SP_ball_weight;
extern float SP_ball_speed_max;
extern float SP_baccel_max;
extern float SP_dash_power_rate;
extern float SP_kick_power_rate;
extern float SP_kickable_margin;
extern float SP_kickable_area;
extern float SP_ctl_radius;
extern float SP_ctl_radius_width;
extern float SP_catch_prob;
extern float SP_catch_area_l;
extern float SP_catch_area_w;
extern int   SP_catch_ban_cycle;
extern int   SP_goalie_max_moves;
extern float SP_max_power;
extern float SP_min_power;
extern float SP_max_moment;
extern float SP_min_moment;
extern float SP_min_neck_angle;
extern float SP_max_neck_angle;
extern float SP_min_neck_moment;
extern float SP_max_neck_moment;
extern float SP_visible_angle;
extern float SP_audio_cut_dist;
extern float SP_dist_qstep;
extern float SP_land_qstep;
extern float SP_dir_qstep;
extern float SP_dist_qstep_l;
extern float SP_dist_qstep_r;
extern float SP_land_qstep_l;
extern float SP_land_qstep_r;
extern float SP_dir_qstep_l;
extern float SP_dir_qstep_r;
extern float SP_ckmargin;
extern float SP_wind_dir;
extern float SP_wind_ang;
extern float SP_wind_force;
extern float SP_wind_rand;
extern bool SP_wind_none;
extern bool SP_wind_random;
extern int   SP_half_time;
extern int   SP_port;
extern int   SP_coach_port;
extern int   SP_olcoach_port;
extern int   SP_simulator_step;
extern int SP_send_step;
extern int SP_recv_step;
extern int SP_lcm_step;
extern int SP_say_msg_size;
extern int SP_hear_max;
extern int SP_hear_inc;
extern int SP_hear_decay;
extern bool SP_coach_mode;
extern bool SP_coach_w_referee_mode;
extern int SP_say_coach_cnt_max;
extern int SP_say_coach_msg_size;
extern int SP_send_vi_step;
extern int SP_look_step;
extern bool SP_use_offside;
extern bool SP_forbid_kickoff_offside;
extern int SP_verbose;
extern float SP_offside_area;
extern float SP_inertia_moment;
extern int SP_sense_body_step;
extern float SP_offside_kick_margin;
extern bool SP_record_messages;
extern bool SP_rec_log;
extern int SP_rec_ver;
extern bool SP_send_log;
extern float SP_slow_down_factor;
extern bool SP_old_hear;
extern int SP_sv_step;
extern char SP_host[20];
extern int SP_drop_ball_time;

const int SP_Hold_Time = 2000;

extern float SP_midfieldline;
extern float SP_backfieldline;
extern float SP_left_wing;
extern float SP_right_wing;

extern int SP_clang_win_size;
extern int SP_clang_define_win;
extern int SP_clang_meta_win;
extern int SP_clang_advice_win;
extern int SP_clang_info_win;
extern int SP_clang_mess_delay;
extern int SP_clang_mess_per_cycle;

extern int SP_player_types;
extern int SP_subs_max;
extern float SP_player_speed_max_delta_min;
extern float SP_player_speed_max_delta_max;
extern float SP_stamina_inc_max_delta_factor;
extern float SP_player_decay_delta_min;
extern float SP_player_decay_delta_max;
extern float SP_inertia_moment_delta_factor;
extern float SP_dash_power_rate_delta_min;
extern float SP_dash_power_rate_delta_max;
extern float SP_player_size_delta_factor;
extern float SP_kickable_margin_delta_min;
extern float SP_kickable_margin_delta_max;
extern float SP_kick_rand_delta_factor;
extern float SP_extra_stamina_delta_min;
extern float SP_extra_stamina_delta_max;
extern float SP_effort_max_delta_factor;
extern float SP_effort_min_delta_factor;
extern float SP_win_no;
extern float SP_win_random;
extern int SP_say_cnt_max;
extern int SP_say_coach_msg_size;

const int SP_max_playertypes = 7;
/**************       Client  Params   *********************/
extern bool CP_goalie;
extern float CP_conf_max;
extern float CP_min_valid_conf;
extern float CP_conf_decay;

const int CP_num_stored_CMDs = 50;
const int CP_num_commands_at_one_cycle = 5;

/*******      Log      ************/
const int CP_matrix_max = 10;
extern int  CP_log_max;
extern char CP_logfile[100];
extern char CP_recfile[100];
extern char CP_IT_weightfile[100];
extern char CP_IT_ref_weigthfile[100];
extern char CP_IT_time_weightfile[100];
extern char CP_PASS_weightfile[100];
extern char CP_SHOOT_weightfile[100];
extern char CP_CB_weightfile[100];
extern char CP_Sensitivity_weightfile[100];
extern char CP_Off_sen_weightfile[100];
extern char CP_FM_offense_weightfile[100];
extern char CP_FM_defense_weightfile[100];
extern char CP_DF_formation_priority_file[100]; 
extern char CP_DF_press_priority_file[100]; 
extern char CP_matrixfile[100];
extern char CP_m_file[CP_matrix_max][100];
extern char CP_DF_Sensitivity_weightfile[100]; 
extern char CP_Mark_priority_weightfile[100]; 
extern char CP_Block_priority_weightfile[100]; 
extern char CP_deviation_weightfile[100]; 
extern float CP_goalie_kick_min_vel;
extern float CP_deviation_max;  
extern int CP_setplay_wait_time;
const int CP_NumGoalieMovePoint = 6;
/************************************/
extern char CP_TeamName[100];
extern char CP_Opp_TeamName[100];

/*********    Display to windows  *****************/
const int CP_MaxLines =33;
const int CP_MaxRows = 100;
/************************************/

extern int CP_Number;

/*********   Role   ********************/
extern float CP_attackness;
extern float CP_leftness;
extern float CP_aggressiveness;
extern float CP_creativeness;
/************************************/

/*************************************************/
extern int   CP_encryption_matrix;
extern int   CP_encryption_key;
extern int   CP_decryption_key;
/*************************************************/
extern float CP_pass_ball_speed_max;
extern float CP_assumed_interceptspeed;
extern float CP_close_ball;
/*************************/
extern char CP_appname[100];
/*************************/
extern float CP_reliable_kickarea;
extern float CP_desired_kickarea;
extern float CP_anticollision_kickarea;
/***** turn ball ******************/
extern float CP_collision_buffer;
extern float CP_turnball_radius;
extern float CP_turnball_radius_threshold;
extern float CP_kickballaway_speed;
extern float CP_block_speed;
extern float CP_pos_deviation_max;
extern float CP_goto_allowed_error;
extern float CP_out_of_pitch_error;
/**************************************************/
extern float CP_division;
const int   CP_num_divisions = 48;
extern int   CP_decision_holdtime;
extern float CP_block_margin;
extern float CP_control_margin;
extern float CP_dribble_speed;
extern float CP_dribble_radius;
extern float CP_dribble_angle;
extern float CP_drweight_conf_a;
extern float CP_drweight_conf_b;
extern float CP_drweight_conf_c;
extern float CP_passweight_conf_a;
extern float CP_passweight_conf_b;
extern float CP_passweight_conf_c;
extern float CP_passable_angle;
extern float CP_passable_distance;
/*************** shoot  *******************/
extern float CP_max_shoot_distance;
extern float CP_goalie_catch_angle;
extern float CP_player_intercept_angle;
extern float CP_shoot_search_angle;
extern float CP_dribble_distance;
extern float CP_setplay_speed;
extern float CP_setplay_deviation;
extern float CP_defense_area_length;
extern float CP_defense_area_width;
extern float CP_block_speed;
extern float CP_block_speed_factor;
extern float CP_max_IT_cycles;
extern float CP_offeseposition_speed;
extern float CP_block_dist;
extern float CP_mark_dist;
extern float CP_check_dist;
extern float CP_mark_speed;
extern float CP_kick_threshold_factor;
extern float CP_mnmx_kickeffect;
const int   CP_max_passinfos = 500;
const int   CP_max_shootinfos = 50;
const int	CP_max_checkshoot = 3;
const int	CP_min_shootangle = 1;
const float CP_shootangle_tolerance = 6.0f;
//position speed
const float CP_fast_formation_speed = 1.0f;
const float CP_mid_formation_speed = 0.5f; 
const float CP_slow_formation_speed = 0.4f;
extern float CP_goalie_safe_catch_length;
const int CP_closeinterception_max_cycles = 5;
const int CP_PIT_max_cycles=12;
const int CP_max_visualrequests = 50;
const int CP_max_actions = 20;
extern float CP_safecatch_width; 

/***************************************************/
extern int FP_goalie_number;
extern int FP_theirgoalie_number;
extern float FP_attackness[SP_team_size];
extern float FP_leftness[SP_team_size];
extern float FP_aggressiveness[SP_team_size];
extern float FP_creativeness[SP_team_size];
extern float CP_goalie_clear_ang;
extern float CP_clear_angle;
extern float CP_goalie_clear_search_ang;
extern float CP_reliable_kickable_area;
extern float CP_powerkick_radius;
extern float CP_kickable_area;

extern float CP_collision_threshold;
const int	 CP_totaldirs = 12;
/****************************************************/
extern float CP_too_different_distance;
extern float CP_identify_min_conf;
extern float CP_different_distance;
const int CP_num_stored_sensoryinfos = 8;
const int CP_num_stored_markerinfos = 3;
extern float CP_negativepower_factor;
extern float CP_collision_detected_threshold;
/****************************************************/
extern float CP_selfvel_mingap;
extern float CP_VW_Narrowfactor;
extern float CP_def_concern_area;
/**************** const *****************************/
const int CP_max_msgdata = 10;
const float CP_impossible_speed = 3.0f;
const float CP_latent_max_area = 15.0f;
const int CP_max_bvalidcycles = 10;

const float CP_OA_stepcost = -0.09f;
const int CP_OA_maxdepth = 5;
const int CP_OA_maxsteps = 10;
extern char CP_KickOA_weightfile_A[100];
extern char CP_KickOA_weightfile_B[100];
extern char CP_KickOA_weightfile_C[100];
extern char CP_KickOA_weightfile_D[100];
extern float CP_kickarea_compensation;
extern float CP_catcharea_compensation;
const int CP_max_visible_players = SP_team_size + SP_team_size / 2;
const int CP_max_considerd_pass_players = 2 * CP_max_visible_players;
const int CP_max_considered_pass_routes = 30;
extern float CP_sensitivity_distance;
extern float CP_k_dribble_avoid;
extern float CP_k_dribble_rosen;
extern float CP_shoot_avoidgoalie;
#endif