/*
    Copyright (C) 2001  Tsinghuaeolus

    Authors : ChenJiang, YaoJinyi, CaiYunpeng, Lishi

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

	If you make any changes or have any comments we would appreciate a 
	message to yjy01@mails.tsinghua.edu.cn.
*/

#ifndef _positioning
#define _positioning
#include "bpn.h"
#include "types.h"
#include "Command.h"
#include "Strategy.h"
#include "df_positioning.h"

class PositionAction{
protected:
	Vector point;
	float  rapidness;
	float max_deviation;
	float priority;
	ActionType actiontype;
public:
	PositionAction();
	float GetPriority();
	ActionType GetActionType(){ return actiontype;};
	void SetPositioningInfo(Vector point, float rapidness, float max_deviation, float priority, ActionType actiontype);
	void position();
};

class Positioning : public DF_positioning, public PositionAction{
private:
public:
	TimedDataArray<DF_Arrangement, 3> logdefense;

	Positioning();
	
	void Position();
	void Defense();
	void Offense();
	void OffensiveFormation();
	void DefensiveFormation();
	float GetDefenseSpeed(const DF_Arrangement & arrangement);
	void CloseBlock(DF_Arrangement &arrangement);
};
#endif